/* 
   manaemori --- a keeper of manae
   mmprefs.c --- setting preferences
   Copyright 1998-2002 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/
#ifndef _MMPREFS_C_
#define _MMPREFS_C_

#include <PalmOS.h>
#include "manae.h"
#include "manaemori.h"
#include "mmid.h"
#include "myfunc.h"

static void *GetObjectPtr(UInt16 objectID)
{
  FormPtr frmP;

  frmP = FrmGetActiveForm();
  return(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID)));
}

Err MMPrefsSet(ManaeMoriPrefsType mmPrefs)
{
  PrefSetAppPreferences(MMCREATOR, PREFID0, VERSION, &mmPrefs,
			sizeof(ManaeMoriPrefsType), true);
  return(errNone);
}

static ManaeMoriPrefsType MMPrefsSetDefault()
{
  ManaeMoriPrefsType mmPrefs;

  mmPrefs.hardKey = false;
  mmPrefs.jog = false;
  mmPrefs.tap = false;
  mmPrefs.reserve1 = 0;
  mmPrefs.reserve2 = 0;
  mmPrefs.reserve3 = 0;
  mmPrefs.reserve4 = 0;
  mmPrefs.deviceType = 0; //
  mmPrefs.jogType = 0; //
  MMPrefsSet(mmPrefs);
  return(mmPrefs);
}

/*
Err MMKeyTransTblSet(keyTransTblType t[KEY_TRANS_TBL_SIZE],
		     Boolean hardKeyF,
		     Boolean sonyF,
		     Boolean trgF)
{
  Int16 i;
  i = 0;

  t[i].mode = HIRA;
  t[i].kanjiMode = KANJI;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;
  t[i].mode = ;
  t[i].kanjiMode = ;
  t[i].inputC = ;
  t[i].outputC = ;
  t[i].fakeC = ;
  i++;

}
*/

Err MMPrefsGet(ManaeMoriPrefsType *mmPrefs)
{
  Int16 i;
  UInt16 prefsSize;

  prefsSize = 0;

  i = PrefGetAppPreferences(MMCREATOR, PREFID0, NULL, &prefsSize, true);

  if ((i == noPreferenceFound) || (prefsSize != sizeof(ManaeMoriPrefsType))) {
    MMPrefsSetDefault();
   }

  i = PrefGetAppPreferences(MMCREATOR, PREFID0, mmPrefs, &prefsSize, true);

  if ((i == noPreferenceFound) || (prefsSize != sizeof(ManaeMoriPrefsType))) {
    return(ERR_1);
  }
  
  return(errNone);
}

Err MMPrefsShow(ManaeMoriPrefsType mmPrefs)
{
  ControlType *ctlP;

  ctlP = GetObjectPtr(ID_MM_PREFS_HARDKEY_CHECKBOX);
  CtlSetValue(ctlP, (short)mmPrefs.hardKey);
  ctlP = GetObjectPtr(ID_MM_PREFS_JOG_CHECKBOX);
  CtlSetValue(ctlP, (short)mmPrefs.jog);
  ctlP = GetObjectPtr(ID_MM_PREFS_TAP_CHECKBOX);
  CtlSetValue(ctlP, (short)mmPrefs.tap);
  return(errNone);
}

Err MMPrefsApply(ManaeMoriPrefsType *mmPrefsP)
{
  
  mmPrefsP->hardKey =
    (Boolean)CtlGetValue(GetObjectPtr(ID_MM_PREFS_HARDKEY_CHECKBOX));
  mmPrefsP->jog =
    (Boolean)CtlGetValue(GetObjectPtr(ID_MM_PREFS_JOG_CHECKBOX));
  mmPrefsP->tap =
    (Boolean)CtlGetValue(GetObjectPtr(ID_MM_PREFS_TAP_CHECKBOX));
  return(errNone);
}

Boolean MMPrefsHandleEvent(EventPtr eventP)
{
  Boolean handled = false;
  FormPtr frmP;
  ManaeMoriPrefsType mmPrefs;

  if (eventP->eType == ctlSelectEvent) {
      switch (eventP->data.ctlSelect.controlID) {
      case ID_MM_PREFS_ADV_BUTTON:
	//	MyPopupModalForm(ID_MM_ADV_FORM, MMAdvFormHandleEvent);
	//	handled = true;
	break;
      case ID_MM_PREFS_DONE_BUTTON:
	{
	  ManaeMoriPrefsType mmPrefs;
	  MMPrefsApply(&mmPrefs);
	  MMPrefsSet(mmPrefs);
	}
	FrmGotoForm(9000);
	handled = true;
	break;
	
      }
    }
  else if (eventP->eType == frmLoadEvent) {
    UInt16 formID;

    WinDrawChars("frmLoadEvent", 10, 0, 0);
    formID = eventP->data.frmLoad.formID;
    frmP = FrmInitForm(formID);
    FrmSetActiveForm(frmP);

    switch (formID) {
    case ID_MM_PREFS_FORM:
      //      FrmSetEventHandler(frmP, MMPrefsFormHandleEvent);
      MMPrefsGet(&mmPrefs);
      MMPrefsShow(mmPrefs);
      return(true);
      break;

    case ID_MM_ADV_FORM:
      //      FrmSetEventHandler(frmP, MMAdvFromHandleEvent);
      return(true);
      break;

    default:
      break;
    }
  }
  else if (eventP->eType == frmOpenEvent) {
    frmP = FrmGetActiveForm();
    //      PrefsInit();
    MMPrefsGet(&mmPrefs);
    MMPrefsShow(mmPrefs);
    FrmDrawForm(frmP);
    handled = true;
  }
  else if (eventP->eType == frmCloseEvent) {
    handled = true;
  }
  
  return (handled);
}

#endif
